/* Wine Profiler
 *
 * Copyright 2000-2003 Codeweavers, Charles Loep
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __WINEPROF_H__
#define __WINEPROF_H__

struct callinfo_s;
struct symbol_s;
struct profile_s;


typedef struct callinfo_s {
	counter32_t      calls;
	counter64_t      ticks;
	struct symbol_s *caller;
} callinfo_t;


typedef struct symbol_s {
	char         *name;
	char         *soname;
	char         *source;
	unsigned int  addr;
	counter32_t   count;
	counter64_t   ticks;
	counter64_t   ticks_self;
	counter64_t   ticks_kids;
	GList        *callers;
} symbol_t;

typedef struct profile_s {
	int             fd;
	wprof_header_t *header;
	GHashTable     *symtab;
	GList          *symlist;
	counter64_t     total_ticks;
} profile_t;


#endif /*__WINEPROF_H__*/
